Shops = {}
Size = {100,100}
AmountofShops = 10
FieldImage = nil
Mode = "Euclidean"

function CreateShops(amount,reset)
	if reset then
		Shops = {}
	end
	for Shop = 1,amount do
		local NewShop = {
			Position = {math.random(0,Size[1]),math.random(0,Size[2])},
			Color = {math.random(1,255),math.random(1,255),math.random(1,255)}
		}
		table.insert(Shops,NewShop)
	end
end
CreateShops(AmountofShops,true)

function Distance(x1,y1,x2,y2,mode)
	if mode == "Euclidean" then
		return ((x1-x2)^2+(y1-y2)^2)^0.5
	elseif mode == "Manhattan" then
		return math.abs(x1-x2)+math.abs(y1-y2)
	end
end

function CalculateClosestShop(x,y)
	local ClosestShop = Shops[1]
	local ClosestDistance = 9999
	for i,Shop in pairs(Shops) do
		local DistanceToCurrentShop = Distance(x,y,Shop.Position[1],Shop.Position[2],Mode)
		if DistanceToCurrentShop < ClosestDistance then
			ClosestDistance = DistanceToCurrentShop
			ClosestShop = Shop
		end
	end
	return ClosestShop
end

function CalculateField()
	local imgData = love.image.newImageData(Size[1],Size[2])	
	for x = 0,Size[1]-1 do
		for y = 0,Size[2]-1 do
			local ClosestShop = CalculateClosestShop(x,y)
			imgData:setPixel(x,y,ClosestShop.Color[1],ClosestShop.Color[2],ClosestShop.Color[3], 255)
		end
	end
	FieldImage = love.graphics.newImage(imgData)
end
CalculateField()

function love.keypressed(key)
	if key == "w" then
		AmountofShops = AmountofShops+1
		CreateShops(AmountofShops,true)
	elseif key == "s" then
		AmountofShops = AmountofShops-1
		CreateShops(AmountofShops,true)
	elseif key == "d" then
		Size = {Size[1]+20,Size[2]+20}
	elseif key == "a" then
		Size = {Size[1]-20,Size[2]-20}
	elseif key == "m" then
		if Mode == "Euclidean" then
			Mode = "Manhattan"
		elseif Mode == "Manhattan" then
			Mode = "Euclidean"
		end
	end
	CalculateField()
end

function love.draw()
	love.graphics.draw(FieldImage,0,0)
	love.graphics.print("Change Size with A and D, change amount of Shops with W and S, change Distane Mode with M",0,Size[2])
	love.graphics.print("Current Mode : "..Mode,0,Size[2]+15)
end